/*  File:   main.c 1
 * gakufu ́A16 bit PʁB
 * ŏɃe|(1Ԃɉtl̐jL^ĂB
 * ȍ~͉ MSB 8 bit̍B PʂŁÃh 60(0x3C)
 *                LSB 8 bit̒
 *     QF10A    SF08A    WF04A    PUF02
 * t_QF18At_SF0CAt_WF06At_PUF03
 *      | 7 6 5 4 3 2 1 0| 7 6 5 4 3 2 1 0 |
 *      |            |             |
 *     Language: MPLABX XC8
 *     Target: PIC12F1822
 */
// x  wl(ms)1/16
#define EnvelopeConst 50
// Ɖ̊Ԃ̖(ms)
#define Silent        30

#include "xc.h"
#include "gakufu.h"
#define _XTAL_FREQ 8000000
#define SW        RA5
#define SPK        LATA2
#define TRIS_SPK   TRISA2
#define TRIS_LED   TRISA4
#define LED        LATA4
#define waitStart  0
#define getGakufu  1
#define getOnpu    2
#define onpuStart  3
#define onpuPlay   4
#define onpuEnd    5
#define gkfEnd     6

#pragma config FOSC = INTOSC, WDTE = OFF, PWRTE = OFF, MCLRE = OFF, CP = OFF
#pragma config CPD = OFF, BOREN = ON, CLKOUTEN = OFF, IESO = OFF, FCMEN = OFF
#pragma config WRT = OFF, PLLEN = OFF, STVREN = ON, BORV = LO, LVP = OFF

// ̍߂萔  for 8MHz Fosc   PWM Freq 16.525kHz
const unsigned int dW_tbl[] = { 
//  Do,   Do#,  Re,   Re#,  Mi,   Fa,   Fa#,  So,   So#,  Ra,   Ra#,  Si,
  0,0x112,0x122,0x133,0x146,0x159,0x16E,0x183,0x19B,0x1B3,0x1CD,0x1E8,0x205, //12
    0x224,0x245,0x267,0x28C,0x2B3,0x2DC,0x307,0x336,0x366,0x39A,0x3D1,0x40B,
    0x449,0x48A,0x4CF,0x518,0x566,0x5B8,0x60F,0x66C,0x6CD,0x735,0x7A3,0x817,
    0x892,0x915,0x99F,0xA31,0xACD,0xB71,0xC1F,0xCD8,0xD9B,0xE6A,0xF46,0x102E,
    0x1125,0x122A,0x133E,0x1463,0x159A,0x16E3,0x183F,0x19B0,0x1B37,0x1CD5,0x1E8C,0x205D,
    0x224A,0x2454,0x267D,0x28C7,0x2B34,0x2DC6,0x307E,0x3361,0x366F,0x39AB,0x3D19,0x40BB
};  // 0x892(index 37) S̃h(60 0x3E) ,0xD9B ̓ (440Hz)

unsigned int accWave,incWave;
unsigned char amp,wave;

void main(void) {
    char SWdown=0;           // SW ̃tO
    char SWnotRdy=0;         // SW `^Oh~
    char state = 0;          // Xe[g
    unsigned int pOnp = 0;   // ʒu
    unsigned int Onp;        // 
    unsigned char tempo;     // e|
    unsigned char tPlay;     // t
    char AmpCnt = 25;        // U
    char TmpCnt = 65;        // e|
    char TmpFlg = 0;         // e|tO
    char SltCnt = 20;        // 
    char SltFlg = 0;         // tO
    char ampNext;            // 

    OSCCON = 0b01110000;     // NbN 8Mhz
    ANSELA = 0;              // SăfW^IO
    LATA = 0;
    TRIS_SPK = 0;            // SPK RA2 o
    SPK = 0;                 // SPK óu0]
    TRIS_LED = 0;            // LED RC2 o
    LED = 0;                 // LED 
    nWPUEN = 0;              // vAbv L
    // Timer1 ̐ݒ ------------------------------------
    T1CON = 0b01000001;      // Fosc ps 1/1 TMR1ON
    TMR1 = 0xE100;           // +7936 (0.992ms)  Carry
    TMR1IF = 0;              // Timer1tONA
    // PWM Timer2 ̐ݒ ------------------------------------
    T2CON = 0b00000100;      // Timer2 ON PreS 1/1
    PR2      = 0x7F;         // JԂg 15.625KHz
    TMR2IF = 0;              // Timer2tONA
    TMR2IE = 1;              // Timer2ݗL
    PEIE = 1;                // ytFݗL

    while(1){
        //------------ 1ms ̃^C~O ----------------------
        if(TMR1IF){                               // 1ms Ɏ{
            TMR1H = 0xE1;                         //  1ms ݒ
            TMR1IF = 0;                           // tONA
            //------- SW`^Oh~ 1ms[v ----------------
            if(SWnotRdy){                         // SWup̊mFȂ
                if(SW)SWnotRdy--;                 //   SWup̊mF[P
                  else SWnotRdy = 5;              //   SWup̊mFl
            }else if(!SW){                        // SWup̊mFς݂DownȂ
                    SWdown=1;                     //   SWꂽ}[N
                    SWnotRdy = 5;                 //   SWup̊mF҂
            }
            //------- U 50ms -----------------------------------
            if(AmpCnt-- == 1){
                AmpCnt = EnvelopeConst;           // ʂ 50ms
                amp = (int)amp * 15/16;           // ʂ -6% 
            }
            //------- e| -----------------------------------
            if(TmpCnt-- == 1){
                TmpCnt = tempo;                   // e|
                TmpFlg = 1;                       // e|tOZbg
            }
            //------- Silent -----------------------------------
            if(SltCnt-- == 1){                    // ԂɂȂ
                SltFlg = 1;                       // tOZbg
            }
        }
        //------------------- t[ ---------------
        switch(state){
            case waitStart:             // ====== tJn҂ ======
                if(SWnotRdy)break;                // SW OFF̂
                SWdown=0;                         // SWdown Zbg
                CCP1CON = 0;                      // PWM OFF
                T1CON = 0;                        // Timer1 OFF
                GIE = 0;                          // ݋֎~
                IOCAN5 = 1;                       // SW ON҂
                IOCAF = 0;                        // SW tOZbg
                IOCIE = 1;                        // SW SLEEPċN ON
                NOP();       // -------------------------------------
                SLEEP();     //        ̊ԁ@X[v
                NOP();       // -------------------------------------
                IOCIE = 0;                        // SW SLEEPċN֎~
                CCP1CON = 0b00111100;             // VOPWM _o
                T1CON = 0b01000001;               // Fosc ps 1/1 TMR1ON
                SWdown = 0;                       // SW 
                SWnotRdy = 5;                     // 
                GIE = 1;                          // ݗL
                state = getGakufu;  
                break;
            case getGakufu:             // ====== y̐ݒ ======
                if(p1gkf[pOnp]==0xFFFF)pOnp=0;    // yIȂ擪
                tempo = 7500/p1gkf[pOnp++];       // ỹe|擾                
                TmpCnt = tempo;                   // e|Zbg
                TmpFlg = 0;                       // tOZbg
                state = getOnpu;
                break;
            case getOnpu:               // ====== ̐ݒ ======
                Onp = p1gkf[pOnp++];              // 擾
                if(Onp == 0xFFFF){                // Ȃ̏IȂ
                    state = gkfEnd;               // 
                    break;
                }
                tPlay = Onp & 0x00FF;             // ̒擾
                Onp = Onp >> 8;                   // o
                if(Onp){                          // Ȃ
                    incWave = dW_tbl[Onp - 23];   //  JԂԂɕϊ
                    ampNext = 0x7F;               //  ʍő
                }else{                            // xȂ
                    incWave = 0;                  //  JԂ@Ȃ
                    ampNext = 0;                  //  OFF
                }
                state = onpuStart;
                break;
            case onpuStart:             // ====== ̉tJn ======
                if(TmpFlg){                       // e|҂
                    TmpFlg = 0;                   // e|tOZbg
                    amp = ampNext;                // ʍő
                    if(amp)LED=1;                 // xłȂLED_
                    AmpCnt = EnvelopeConst;       // ʌZbg
                    state = onpuPlay;
                }
                break;
            case onpuPlay:             // ====== ̉tp ======
                if(TmpFlg){                       // e|҂
                    TmpFlg = 0;                   // e|tOZbg
                    if(tPlay-- == 2){             // IȂ
                        SltCnt = tempo - Silent;  //  ԂZbg
                        SltFlg = 0;               //  tOZbg
                        LED=0;                    //  LED
                        state = onpuEnd;
                    }
                    if(SWdown){                   // SWꂽȂ
                        SWdown=0;                 //  SW ςݖ
                        state = gkfEnd;           //  I
                    }
                }
                break;
            case onpuEnd:             // ====== ̉tI ======
                if(SltFlg){                       // Ԃ҂
                    amp = 0;                      // OFF
                    state = getOnpu;              // ̉擾
                }
                break;
            case gkfEnd:              // ====== ỷtI ======
                    LED=0;                        // LED
                    pOnp--;                       // ȏI܂Ői
                    while(p1gkf[pOnp++] != 0xFFFF);
                    state = waitStart;            // tJn҂
                break;
        }
    }   //  while
}

// ݏu -----------------------------------------------------
void interrupt isr(void){
    if(TMR2IF){                                   // Timer2 ݂mF
        TMR2IF = 0;                               // Timer2 tO@Zbg
        accWave += incWave;                       // vZ
        if(STATUSbits.CARRY)wave ^= 1;            // Lo΁Ag`]
        if(wave)CCPR1L = amp;                     // g`ONȂA o͂
        else CCPR1L = 0;                          //     OFFȂAo͂Ȃ
    }
}
